﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;
using System.Threading;
using System.Reflection;
using System.Runtime.InteropServices;

//The source and destination port are the same !!!!

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {

        UdpClient udpclient;
        IPEndPoint remoteipendpoint;
        IPEndPoint sourceipendpoint;
       // IPAddress ipaddress;
        Thread thread;
        private bool run = false;
        string returnData = "--------";                     //received data from UDP(initial value "????????"
        string remoteIP = string.Empty;                     //remote IP
        byte[] receiveBytes = new byte[32];                 //receive data buffer   
        private bool udpCheck = false;                      //Check Open or Close state of the button

        public Form1()
        {
            InitializeComponent();
            FormClosing += new FormClosingEventHandler(Form1_FormClosing);
        }


        //Receiving UDP packets Thread
        private void receiveUDP()
        {

            
            while (run)
            {
                this.Invoke(new EventHandler(statusExpress));
                try
                {
                    receiveBytes = udpclient.Receive(ref remoteipendpoint);
                    remoteIP = remoteipendpoint.Address.ToString();
                    returnData = Encoding.ASCII.GetString(receiveBytes);
                    this.Invoke(new EventHandler(statusExpress));
                }
                catch
                {
                        returnData = "--------";
                        remoteIP = string.Empty;
                        this.Invoke(new EventHandler(statusExpress));
                        
                }
            }
        }


        private void statusExpress(object sender, EventArgs e)
        {
            statusLabel.Text = returnData;
            recipTextBox.Text = remoteIP;
        }

        private void sendButton_Click(object sender, EventArgs e)
        {
            try
            {        
                byte[] command = Encoding.ASCII.GetBytes(commandTextBox.Text.ToUpper());      //nevermind lower or upper - case....
                udpclient.Send(command, command.Length, sourceipendpoint);               
            }

            catch
            {
            }

        }


        private void openPort_Click(object sender, EventArgs e)
        {

            if (udpCheck == false)
            {
                try
                {
                    udpclient = new UdpClient(Int32.Parse(portTextBox.Text));
                    IPAddress ipaddress = IPAddress.Parse(destipTextBox.Text);
                    remoteipendpoint = new IPEndPoint(IPAddress.Any,0);                             //remote port IPEndpoint
                    sourceipendpoint = new IPEndPoint(ipaddress, Int32.Parse(portTextBox.Text));    //source port IPEndpoint
                    udpCheck = true;
                    openPort.Text = "Close Port";
                    run = true;
                    thread = new Thread(new ThreadStart(receiveUDP));
                    thread.IsBackground = true;
                    thread.Start();
                }

                catch
                {

                    MessageBox.Show("Cannot bind the socket", "Error!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    
                    udpCheck = false;
                    try
                    {
                        if (udpclient == null) { }
                        else { udpclient = null; udpclient.Close(); }
                    }

                    catch
                    {
                    }
                    return;
                }
            }

            else
            {
                try
                {
                    udpclient.Close();
                    udpCheck = false;
                    openPort.Text = "Open Port";
                    recipTextBox.Text = string.Empty;
                    thread = null;
                    run = false;
                    thread.Abort();
                }


                catch
                {
                }
            }

        }


        private void Form1_FormClosing(object sender, EventArgs e)
        {
            if (thread != null && thread.IsAlive)
            {
                thread.Abort();
            }
        }



    }
}
